
#ifdef WIN32
	#include <windows.h>
	#pragma comment(lib, "Irrlicht.lib")
#endif

#include <irrlicht.h>

using namespace irr;
using namespace core;
using namespace video;
using namespace scene;

#include <stdarg.h>

void DrawImage(IVideoDriver *driver, char* filename, int x, int y, 
		int w, int h, int u, int v, SColor col, SColor col2, float sx, float sy)
{
	ITexture* texture = driver->getTexture(filename);

	SColor col3 = col2;
	if(col2 == 0)col3 = col;
	SColor color[] = {col,col3,col3,col};//FFEFE
	driver->draw2DImage(texture, rect<s32>(x,y,x+w*sx,y+h*sy), 
		rect<s32>(u,v,u+w,v+h), 0, color, true);
}

void Printf(IVideoDriver *driver, int x, int y, SColor color, const char *fmt, ...)
{
	int i,len;
	va_list ap;
	char tmp[1024];
	char *tex = "japanese.png";

	memset(tmp, 0x00, sizeof(tmp));

	//t𒲐
	va_start(ap, fmt);
	vsprintf(tmp, fmt, ap);
	va_end(ap);

	len = strlen(tmp);

	int posx = 0;			//̕`ʒu
	int posy = 0;			//̕_ʒu
	int tx, ty;				//摜ǂݍ݈ʒu
	int w;					//̕@@p8ASp16
	int h = 16;				//̍@16Œ
	unsigned char buf[2];	//擾ꎞۑ
	
	for(i=0;i<len;i++){
		buf[0] = tmp[i]&0xFF;
		//2oCg`FbN(SJIS)
		if((buf[0] >= 0x80 && buf[0] <= 0x9F) || buf[0] >= 0xE0)
		{
			//2oCg
			w = 16;
			buf[1] = tmp[++i]&0xFF;//̃obt@擾
			//摜ʒuvZ
			tx = ((buf[1]-0x40)%64)*h;						
			ty = (1+(buf[0]-0x81)*3+(buf[1]-0x40)/64)*h;
			DrawImage(driver,tex,x+posx,y+posy,w,h,tx,ty,color,color,1,1);
			posx += w;
		}
		else
		{
			//1oCg
			w = 8;
			switch(buf[0])
			{
				//s
				case '\n':
					posx = 0;		//Jnʒu0ɂ
					posy += h;		//̍炷
					break;
				//^u
				case '\t':
					posx += w*4;	//p4炷
					break;
				//ʏ핶
				default:
					//摜ʒuvZ
					tx = (buf[0]-0x20)*w;
					ty = 0;
					DrawImage(driver,tex,x+posx,y+posy,w,h,tx,ty,color,color,1,1);
					posx += w;
					break;
			}
		}
	}
}

void makeScene(IVideoDriver *driver)
{
	char* mess = "vZ:";
	Printf(driver,0,0,0xFFFFFFFF, 
		"ɂIrrlicht\n\t%s 10+20=%d", mess, 10+20);
	Printf(driver,0,120,0xFFFFFF00,"F̂");
}

#ifdef WIN32
	int WINAPI WinMain(HINSTANCE hInst, HINSTANCE hPrevInst, LPSTR strCmdLine, int nShowCmd)
#else
	int main()
#endif
{
	IrrlichtDevice *device = createDevice(EDT_OPENGL,dimension2d<s32>(320,240),16,false,false,0);
	IVideoDriver *driver = device->getVideoDriver();
	ISceneManager* smgr  = device->getSceneManager();

	device->setWindowCaption(L"Irrlicht");//EChE^Cgݒ

	//Cg
	smgr->addLightSceneNode(0, vector3df(0,0,-1000), SColorf(0xFFFFFFFF), 1000.0f);

	//Jݒ
	smgr->addCameraSceneNode(0, vector3df(0,0,-5), vector3df(0,0,0));

	while(device->run())
	{
		driver->beginScene(true,true,0xFF6060FF);

		//}`쐬
		makeScene(driver);

		//V[̕`
		smgr->drawAll();

		driver->endScene();
	}

	driver->drop();

	return 0;
}
